// -*- c++ -*-
/**************************************************************/
/*  This file is licensed from, and is a trade secret of:     */
/*                                                            */
/*    Mercury Computer Systems, Incorporated                  */
/*    199 Riverneck Road                                      */
/*    Chelmsford, Massachusetts 01824-2820                    */
/*    United States of America                                */
/*    Telephone + 1 978 256-1300                              */
/*                                                            */
/*  Refer to your Software License Agreement for provisions   */
/*  on use, duplication, or disclosure.                       */
/*  US. Government users and prime contractors are also       */
/*  governed by the following Data Rights Notice:             */
/*  Use, duplication or disclosure by the US. Government is   */
/*  subject to the provisions set forth in FAR 52.227-14 for  */
/*  restricted rights or other agency data rights provisions  */
/*  on commercial software and documentation, as applicable.  */
/*                                                            */
/*  This file: (a) was developed at private expense, and no   */
/*  part was developed with government funds, (b) is a        */
/*  trade secret of Mercury Computer Systems, Inc. for the    */
/*  purposes of the Freedom of Information Act, (c) is        */
/*  "commercial computer software" subject to limited         */
/*  utilization as provided in the above noted Software       */
/*  License Agreement and (d) is in all respects data         */
/*  belonging exclusively to Mercury Computer Systems, Inc..  */
/*                                                            */
/**************************************************************/

/******************************************************************/
/* Copyright (c) 1999-2003, Mercury Computer Systems, Inc.,       */
/* Chelmsford MA.,and all third party embedded software sources.  */
/* All rights reserved under the Copyright laws of US. and        */
/* international treaties.                                        */
/*                                                                */
/* Patent Pending                                                 */
/******************************************************************/


//$COPYRIGHT_END


#ifndef CF__Resource_impl_h
#define CF__Resource_impl_h


// Disable the warning for inheritance.
#ifdef WIN332
#pragma warning(disable: 4250)
#endif

#include <string>
#include <stdlib.h>
#include "cfS.h"
#include "cf__exp.h"
#include "CF__LifeCycle_impl.h"
#include "CF__TestableObject_impl.h"
#include "CF__PropertySet_impl.h"
#include "CF__PortSupplier_impl.h"


class __CF_EXPORT__ CF__Resource_impl :
  public virtual POA_CF::Resource,
  public CF__LifeCycle_impl,
  public CF__TestableObject_impl,
  public CF__PropertySet_impl,
  public CF__PortSupplier_impl,
  public virtual PortableServer::RefCountServantBase
{
public:
  CF__Resource_impl (const char * identifier);
  virtual ~CF__Resource_impl ();

  virtual CORBA::Char* identifier ()
    throw (CORBA::SystemException);

  virtual void configure (const CF::Properties & configProperties)
    throw (CORBA::SystemException, CF::PropertySet::InvalidConfiguration,
           CF::PropertySet::PartialConfiguration);
  virtual void query (CF::Properties & configProperties)
    throw (CORBA::SystemException, CF::UnknownProperties);

  virtual void initialize ()
    throw (CORBA::SystemException, CF::LifeCycle::InitializeError);

  virtual void start ()
    throw (CORBA::SystemException, CF::Resource::StartError);
  virtual void stop ()
    throw (CORBA::SystemException, CF::Resource::StopError);

protected:
    CORBA::String_var m_identifier;
    CORBA::Boolean m_initialized;

private:
    CF__Resource_impl(const CF__Resource_impl & obj);
};

#endif
