// -*- c++ -*-
/**************************************************************/
/*  This file is licensed from, and is a trade secret of:     */
/*                                                            */
/*    Mercury Computer Systems, Incorporated                  */
/*    199 Riverneck Road                                      */
/*    Chelmsford, Massachusetts 01824-2820                    */
/*    United States of America                                */
/*    Telephone + 1 978 256-1300                              */
/*                                                            */
/*  Refer to your Software License Agreement for provisions   */
/*  on use, duplication, or disclosure.                       */
/*  US. Government users and prime contractors are also       */
/*  governed by the following Data Rights Notice:             */
/*  Use, duplication or disclosure by the US. Government is   */
/*  subject to the provisions set forth in FAR 52.227-14 for  */
/*  restricted rights or other agency data rights provisions  */
/*  on commercial software and documentation, as applicable.  */
/*                                                            */
/*  This file: (a) was developed at private expense, and no   */
/*  part was developed with government funds, (b) is a        */
/*  trade secret of Mercury Computer Systems, Inc. for the    */
/*  purposes of the Freedom of Information Act, (c) is        */
/*  "commercial computer software" subject to limited         */
/*  utilization as provided in the above noted Software       */
/*  License Agreement and (d) is in all respects data         */
/*  belonging exclusively to Mercury Computer Systems, Inc..  */
/*                                                            */
/**************************************************************/

/******************************************************************/
/* Copyright (c) 1999-2003, Mercury Computer Systems, Inc.,       */
/* Chelmsford MA.,and all third party embedded software sources.  */
/* All rights reserved under the Copyright laws of US. and        */
/* international treaties.                                        */
/*                                                                */
/* Patent Pending                                                 */
/******************************************************************/


#ifndef MC_COMPONENT_FILE_IO_H
#define MC_COMPONENT_FILE_IO_H

#define IO_FRAME_SIZE	72	// # of symbols/output frame

enum IODataType {
    FILE_IO_DT_OCTET,
    FILE_IO_DT_CHAR,
    FILE_IO_DT_SHORT,
    FILE_IO_DT_USHORT,
    FILE_IO_DT_LONG,
    FILE_IO_DT_ULONG,
    FILE_IO_DT_FLOAT,
    FILE_IO_DT_DOUBLE
};

#define DT_OCTET_TYPE_STR "octet"
#define DT_CHAR_TYPE_STR "char"
#define DT_SHORT_TYPE_STR "short"
#define DT_USHORT_TYPE_STR "ushort"
#define DT_LONG_TYPE_STR "long"
#define DT_ULONG_TYPE_STR "ulong"
#define DT_FLOAT_TYPE_STR "float"
#define DT_DOUBLE_TYPE_STR "double"

extern enum IODataType ConvertStringToDataTypeEnum (const char *data_type_string);
extern size_t GetSizeOfDataType (enum IODataType data_type);

#endif
